# BEGIN SourceDeps(oneline):
BuildRequires(pre): rpm-build-python
# END SourceDeps(oneline)
%py_provides holland hldump
%filter_from_requires /python....exc./d
%define oldname holland
# fedora bcond_with macro
%define bcond_with() %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}
# redefine altlinux specific with and without
%define with()         %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()      %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}

# we don't do the condition check as per FPG because we are targeting
# el4 also... which doesn't support it
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}

%{!?holland_version: %global holland_version 1.0.6}

# default %%rhel to make things easier to build
%{!?rhel: %global rhel %%(%{__sed} 's/^[^0-9]*\\([0-9]\\+\\).*/\\1/' /etc/redhat-release)}

# added here for el4 with/without/bcond_with/bcond_without support
%if %{!?with:1}0
%global with() %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%endif
%if %{!?without:1}0
%global without() %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%endif
%if %{!?bcond_with:1}0
%global bcond_with() %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%endif
%if %{!?bcond_without:1}0
%global bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}
%endif

# this is reverse logic.  those listed by bcond_with are disabled by default
%bcond_with     tests
%bcond_with     example 
%bcond_with     sphinxdocs
%bcond_with     mysqlhotcopy
%bcond_with     maatkit
%bcond_with     random
%bcond_with     sqlite
%bcond_without  pgdump
%bcond_without  xtrabackup

Name:           python-module-holland
Version:        %{holland_version}
Release:        alt1_8
Summary:        Pluggable Backup Framework
Group:          Development/Python
License:        BSD 
URL:            http://hollandbackup.org
Source0:        http://hollandbackup.org/releases/stable/1.0/%{oldname}-%{version}.tar.gz

BuildArch:      noarch
BuildRequires:  python-devel python-module-setuptools
%if %{with sphinxdocs}
BuildRequires:  python-module-sphinx
%endif

# FIXME: Should be removed after a release or two.  Was added here because the 
# -random package was initially added to the repo but no longer by default.
# Remove if the -random subpackage is re-enabled.
Obsoletes:      %{oldname}-random < 1.0.6

Patch0:         holland-1.0.6-bug706997.patch
Source44: import.info


%description
A pluggable backup framework which focuses on, but is not limited to, highly
configurable database backups.

%package common
Summary:        Common library functionality for Holland Plugins
License:        GPLv2
Group:          Development/Python

%description common
Library for common functionality used by holland plugins

%if %{with example}
%package example
Summary: Example Backup Provider Plugin for Holland
Group: Development/Python

%description example
Example Backup Plugin for Holland
%endif

%if %{with random}
%package random
Summary: Random Backup Provider Plugin for Holland
Group: Development/Python

%description random
Random Backup Provider Plugin for Holland
%endif

%if %{with maatkit}
%package maatkit
Summary: Holland mk-parallel-dump plugin
Group: Development/Python
Requires: maatkit

%description maatkit
This plugin provides support for holland to perform MySQL backups using the 
mk-parallel-dump script from the Maatkit toolkit.
%endif

%package mysqldump
Summary: Logical mysqldump backup plugin for Holland
License: GPLv2
Group: Development/Python

%description mysqldump
This plugin allows holland to perform logical backups of a MySQL database
using the mysqldump command.

%if %{with mysqlhotcopy}
%package mysqlhotcopy
Summary: Raw non-transactional backup plugin for Holland
License: GPLv2
Group: Development/Python

%description mysqlhotcopy
This plugin allows holland to perform backups of MyISAM and other 
non-transactional table types in MySQL by issuing a table lock and copying the
raw files from the data directory.
%endif

%package mysqllvm
Summary: Holland LVM snapshot backup plugin for MySQL 
License: GPLv2
Group: Development/Python
Provides: %{oldname}-lvm = %{version}-%{release}
Obsoletes: %{oldname}-lvm < 0.9.8
Requires: lvm2 tar

%description mysqllvm
This plugin allows holland to perform LVM snapshot backups of a MySQL database
and to generate a tar archive of the raw data directory.

%if %{with pgdump}
%package    pgdump
Summary: Holland Backup Provider for PostgreSQL 
License: GPLv2
Group: Development/Python
Provides: %{oldname}-pgdump = %{version}-%{release}

%description pgdump
This plugin allows holland to backup PostgreSQL databases via the pg_dump command.
%endif

%if %{with sqlite}
%package sqlite
Summary: SQLite Backup Provider Plugin for Holland
Group: Development/Python

%description sqlite 
SQLite Backup Provider Plugin for Holland
%endif

%if %{with xtrabackup}
%package xtrabackup
Summary: Xtrabackup plugin for Holland
License: GPLv2
Group: Development/Python

# we currently do not Require xtrabackup as there are potentially different
# ways to implement holland-xtrabackup (i.e. MySQL-zrm which is commercial)
#
# basically, we want to provide the holland-xtrabackup capability, but 
# fedora stock doesn't support it at this time.
#Requires: xtrabackup >= 1.2

%description xtrabackup
This package provides a Holland plugin for the Percona Xtrabackup 
backup tool for InnoDB and XtraDB engines for MySQL
%endif

%prep
%setup -n %{oldname}-%{version} -q
%patch0 -p1 -b .bug706997

find ./ -name setup.cfg -exec rm -f {} \;
mv plugins/README README.plugins
mv config/providers/README README.providers 

# cleanup, will be removed upstream at some point
rm plugins/ACTIVE

%build
%{__python} setup.py build

%if %{with sphinxdocs}
# docs
pushd docs
make html
rm -f build/html/.buildinfo
popd
%endif

# library : holland.lib.common
cd plugins/holland.lib.common
%{__python} setup.py build
cd -
    
# library : holland.lib.mysql
cd plugins/holland.lib.mysql
%{__python} setup.py build
cd -

# library: holland.lib.lvm
cd plugins/holland.lib.lvm
%{__python} setup.py build
cd -

%if %{with example}
# plugin : holland.backup.example
cd plugins/holland.backup.example
%{__python} setup.py build
cd -
%endif

%if %{with maatkit}
# plugin : holland.backup.maatkit
cd plugins/holland.backup.maatkit
%{__python} setup.py build
cd -
%endif

# plugin : holland.backup.mysqldump
cd plugins/holland.backup.mysqldump
%{__python} setup.py build
cd -

%if %{with mysqlhotcopy}
# plugin : holland.backup.mysqlhotcopy
cd plugins/holland.backup.mysqlhotcopy
%{__python} setup.py build
cd -
%endif

# plugin : holland.backup.mysql_lvm
cd plugins/holland.backup.mysql_lvm
%{__python} setup.py build
cd -

%if %{with pgdump}
cd plugins/holland.backup.pgdump
%{__python} setup.py build
cd -
%endif

%if %{with random}
# plugin : holland.backup.random
cd plugins/holland.backup.random
%{__python} setup.py build
cd -
%endif

%if %{with sqlite}
# plugin : holland.backup.sqlite
cd plugins/holland.backup.sqlite
%{__python} setup.py build
cd -
%endif

%if %{with xtrabackup}
cd plugins/holland.backup.xtrabackup
%{__python} setup.py build
cd -
%endif

%install

%{__mkdir} -p   %{buildroot}%{_sysconfdir}/holland/{backupsets,providers} \
                %{buildroot}%{_var}/spool/holland \
                %{buildroot}%{_var}/log/holland/ \
                %{buildroot}%{_mandir}/man5


# holland-core
%{__python} setup.py install -O1 --skip-build --root %{buildroot} --install-scripts %{_sbindir}
install -m 0640 config/holland.conf %{buildroot}%{_sysconfdir}/holland/
%{__mkdir_p} -p %{buildroot}%{_mandir}/man1
install -m 0644 docs/man/holland.1 %{buildroot}%{_mandir}/man1
%{__mkdir_p} %{buildroot}%{python_sitelibdir_noarch}/holland/{lib,backup,commands,restore}

# library : holland.lib.common
cd plugins/holland.lib.common
%{__python} setup.py install -O1 --skip-build --root %{buildroot}
cd -
    
# library : holland.lib.mysql
cd plugins/holland.lib.mysql
%{__python} setup.py install -O1 --skip-build --root %{buildroot}
cd -

# library: holland.lib.lvm
cd plugins/holland.lib.lvm
%{__python} setup.py install -O1 --skip-build --root %{buildroot}
cd -

%if %{with example}
# plugin : holland.backup.example
cd plugins/holland.backup.example
%{__python} setup.py install -O1 --skip-build --root %{buildroot}
cd -
install -m 0640 config/providers/example.conf %{buildroot}%{_sysconfdir}/holland/providers/
%endif

%if %{with maatkit}
# plugin : holland.backup.maatkit
cd plugins/holland.backup.maatkit
%{__python} setup.py install -O1 --skip-build --root %{buildroot}
cd -
install -m 0640 config/providers/maatkit.conf %{buildroot}%{_sysconfdir}/holland/providers/
%endif

# plugin : holland.backup.mysqldump
cd plugins/holland.backup.mysqldump
%{__python} setup.py install -O1 --skip-build --root %{buildroot}
cd -
install -m 0640 config/providers/mysqldump.conf %{buildroot}%{_sysconfdir}/holland/providers/

%if %{with mysqlhotcopy}
# plugin : holland.backup.mysqlhotcopy
cd plugins/holland.backup.mysqlhotcopy
%{__python} setup.py install -O1 --skip-build --root %{buildroot}
install -c -m 0644 docs/man/holland-mysqlhotcopy.5 \
                   %{buildroot}%{_mandir}/man5
cd -
install -m 0640 config/providers/mysqlhotcopy.conf %{buildroot}%{_sysconfdir}/holland/providers/
%endif

# plugin : holland.backup.mysql_lvm
cd plugins/holland.backup.mysql_lvm
%{__python} setup.py install -O1 --skip-build --root %{buildroot}
cd -
install -m 0640 config/providers/mysql-lvm.conf %{buildroot}%{_sysconfdir}/holland/providers/

# plugin : holland.backup.pgdump
%if %{with pgdump}
cd plugins/holland.backup.pgdump
%{__python} setup.py install -O1 --skip-build --root %{buildroot}
cd -
install -m 0640 config/providers/pgdump.conf %{buildroot}%{_sysconfdir}/holland/providers/
%endif

%if %{with random}
# plugin : holland.backup.random
cd plugins/holland.backup.random
%{__python} setup.py install -O1 --skip-build --root %{buildroot}
cd -
install -m 0640 config/providers/random.conf %{buildroot}%{_sysconfdir}/holland/providers/
%endif

%if %{with sqlite}
# plugin : holland.backup.sqlite
cd plugins/holland.backup.sqlite
%{__python} setup.py install -O1 --skip-build --root %{buildroot}
cd -
install -m 0640 config/providers/sqlite.conf %{buildroot}%{_sysconfdir}/holland/providers/
%endif

%if %{with xtrabackup}
# plugin : holland.backup.xtrabackup
cd plugins/holland.backup.xtrabackup
%{__python} setup.py install -O1 --skip-build --root %{buildroot}
cd -
install -m 0640 config/providers/xtrabackup.conf %{buildroot}%{_sysconfdir}/holland/providers/
%endif

# logrotate
%{__mkdir} -p %{buildroot}%{_sysconfdir}/logrotate.d
cat > %{buildroot}%{_sysconfdir}/logrotate.d/holland <<EOF
/var/log/holland.log /var/log/holland/holland.log {
    rotate 4
    weekly
    compress
    missingok
    create root adm
}
EOF


%files
%doc CHANGES.txt README README.plugins README.providers 
%doc INSTALL LICENSE config/backupsets/examples/ 
%if %{with sphinxdocs}
%doc docs/build/html/
%endif
%{_sbindir}/holland
%dir %{python_sitelibdir_noarch}/holland/
%{python_sitelibdir_noarch}/holland/core/
%{python_sitelibdir_noarch}/holland-%{version}-*-nspkg.pth
%{python_sitelibdir_noarch}/holland-%{version}-*.egg-info
%{_mandir}/man1/holland.1*
%{_var}/log/holland/
%{python_sitelibdir_noarch}/holland/commands/*.py*
%attr(0755,root,root) %dir %{_sysconfdir}/holland/
%attr(0755,root,root) %dir %{_sysconfdir}/holland/backupsets
%attr(0755,root,root) %dir %{_sysconfdir}/holland/providers
%attr(0640,root,root) %config(noreplace) %{_sysconfdir}/holland/holland.conf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/logrotate.d/holland
%attr(0755,root,root) %{_var}/spool/holland
# virtual namespaces
%dir %{python_sitelibdir_noarch}/holland/backup/
%dir %{python_sitelibdir_noarch}/holland/restore/
%dir %{python_sitelibdir_noarch}/holland/commands/
%dir %{python_sitelibdir_noarch}/holland/lib/

%files common
%doc plugins/holland.lib.common/{README,LICENSE}
%{python_sitelibdir_noarch}/%{oldname}/lib/compression.py*
%{python_sitelibdir_noarch}/%{oldname}/lib/archive/
%{python_sitelibdir_noarch}/%{oldname}/lib/safefilename.py*
%{python_sitelibdir_noarch}/%{oldname}/lib/which.py*
%{python_sitelibdir_noarch}/%{oldname}/lib/multidict.py*
%{python_sitelibdir_noarch}/%{oldname}/lib/mysql/
%{python_sitelibdir_noarch}/holland.lib.common-%{version}-*-nspkg.pth
%{python_sitelibdir_noarch}/holland.lib.common-%{version}-*.egg-info
%{python_sitelibdir_noarch}/holland.lib.mysql-%{version}-*-nspkg.pth
%{python_sitelibdir_noarch}/holland.lib.mysql-%{version}-*.egg-info

%if %{with example}
%files example
%doc plugins/holland.backup.example/{README,LICENSE}
%{python_sitelibdir_noarch}/holland/backup/example.py*
%{python_sitelibdir_noarch}/holland.backup.example-%{version}-*-nspkg.pth
%{python_sitelibdir_noarch}/holland.backup.example-%{version}-*.egg-info
%config(noreplace) %{_sysconfdir}/holland/providers/example.conf
%endif

%if %{with random}
%files random
%doc plugins/holland.backup.random/{README,LICENSE}
%{python_sitelibdir_noarch}/holland/backup/random.py*
%{python_sitelibdir_noarch}/holland.backup.random-%{version}-*-nspkg.pth
%{python_sitelibdir_noarch}/holland.backup.random-%{version}-*.egg-info
%config(noreplace) %{_sysconfdir}/holland/providers/random.conf
%endif

%if %{with maatkit}
%files maatkit
%doc plugins/holland.backup.maatkit/{README,LICENSE}
%{python_sitelibdir_noarch}/holland/backup/maatkit.py*
%{python_sitelibdir_noarch}/holland.backup.maatkit-%{version}-*-nspkg.pth
%{python_sitelibdir_noarch}/holland.backup.maatkit-%{version}-*.egg-info
%config(noreplace) %{_sysconfdir}/holland/providers/maatkit.conf
%endif

%files mysqldump
%doc plugins/holland.backup.mysqldump/{README,LICENSE}
%{python_sitelibdir_noarch}/holland/backup/mysqldump/
%{python_sitelibdir_noarch}/holland.backup.mysqldump-%{version}-*-nspkg.pth
%{python_sitelibdir_noarch}/holland.backup.mysqldump-%{version}-*.egg-info
%config(noreplace) %{_sysconfdir}/holland/providers/mysqldump.conf

%files mysqllvm
%doc plugins/holland.backup.mysql_lvm/{README,LICENSE}
%{python_sitelibdir_noarch}/holland/backup/mysql*_lvm/
%{python_sitelibdir_noarch}/holland.backup.mysql*_lvm-%{version}-*-nspkg.pth
%{python_sitelibdir_noarch}/holland.backup.mysql*_lvm-%{version}-*.egg-info
%{python_sitelibdir_noarch}/%{oldname}/lib/lvm/
%{python_sitelibdir_noarch}/holland.lib.lvm-%{version}-*-nspkg.pth
%{python_sitelibdir_noarch}/holland.lib.lvm-%{version}-*.egg-info
%config(noreplace) %{_sysconfdir}/holland/providers/mysql-lvm.conf

%if %{with mysqlhotcopy}
%files mysqlhotcopy
%doc plugins/holland.backup.mysqlhotcopy/{README,LICENSE}
%{python_sitelibdir_noarch}/holland/backup/mysqlhotcopy.py*
%{python_sitelibdir_noarch}/holland.backup.mysqlhotcopy-%{version}-*-nspkg.pth
%{python_sitelibdir_noarch}/holland.backup.mysqlhotcopy-%{version}-*.egg-info
%config(noreplace) %{_sysconfdir}/holland/providers/mysqlhotcopy.conf
%{_mandir}/man5/holland-mysqlhotcopy.5*
%endif

%if %{with pgdump}
%files pgdump
%doc plugins/holland.backup.pgdump/{README,LICENSE}
%{python_sitelibdir_noarch}/holland.backup.pgdump-%{version}-*-nspkg.pth
%{python_sitelibdir_noarch}/holland.backup.pgdump-%{version}-*.egg-info
%{python_sitelibdir_noarch}/holland/backup/pgdump/
%config(noreplace) %{_sysconfdir}/holland/providers/pgdump.conf
%endif

%if %{with sqlite}
%files sqlite 
%doc plugins/holland.backup.sqlite/{README,LICENSE}
%{python_sitelibdir_noarch}/holland/backup/sqlite.py*
%{python_sitelibdir_noarch}/holland.backup.sqlite-%{version}-*-nspkg.pth
%{python_sitelibdir_noarch}/holland.backup.sqlite-%{version}-*.egg-info
%config(noreplace) %{_sysconfdir}/holland/providers/sqlite.conf
%endif

%if %{with xtrabackup}
%files xtrabackup
%doc plugins/holland.backup.xtrabackup/{README,LICENSE}
%{python_sitelibdir_noarch}/holland/backup/xtrabackup/
%{python_sitelibdir_noarch}/holland.backup.xtrabackup-%{version}-*-nspkg.pth
%{python_sitelibdir_noarch}/holland.backup.xtrabackup-%{version}-*.egg-info
%config(noreplace) %{_sysconfdir}/holland/providers/xtrabackup.conf
%endif

%changelog
* Thu Feb 21 2013 Igor Vlasenko <viy@altlinux.ru> 1.0.6-alt1_8
- update to new release by fcimport

* Mon Jan 21 2013 Igor Vlasenko <viy@altlinux.ru> 1.0.6-alt1_7
- initial fc import

